#version 420

layout (location = 0) in vec4 Position;		// Positions from the computeShader

uniform mat4 ModelViewMatrix;				// The camera's ViewMatrix

out vData
{
	float TTL1;								// additional vertexData (color could also be here)
} vertex;


void main()
{
	gl_Position = ModelViewMatrix * vec4(Position.xyz, 1.0f);		// gl_Position contains position of current vertex
	vertex.TTL1 = Position.w;										// extracts TTL from vec4
}